; **************  LC ****************

.NOLIST
.include "tn15def.inc"
.equ      OCR1A =$2E
.LIST
; 
.equ      SK   =PB3         ; SK 
.equ      DI   =PB4         ; DI 
;  EEPROM
; 01 -     C .
; 
.equ      Cmax   =$BF       ; max . .  C .
.equ      Nmax   =8         ; max  
.equ      Umax   =$80       ; .  Umax   (0380)
.equ      Umin   =$C0       ; .  Umin   (00C0)
.equ      ConstF =$10       ; const   800-12

          .org  $0000
          rjmp  BEGIN
          nop               ;  
          nop               ; /
          nop               ; /
          nop               ; /
          nop               ; /
          nop               ; /
          rjmp  BEGIN       ; /
          reti              ;  ADC
          .dw   $FFFF
          .dw   $FFFF
          .dw   $FFFF
          .dw   $FFFF

;         .org  $000D
CONIND:   .db   20          ; const .  . N*0,1s (2cek)
CONZAD:   .db   $05         ; const  N*0,1s (0,5cek)
CALIBR:   .db   $8B         ;  

;         .org  $0010
; /  N*0,1cek
; : CONZAD-  N, ZH=0
; . R0, R16, R17, R18, Z

ZADN:     ldi   ZL,low(CONZAD*2) ;  N
          lpm
          mov   R18,R0      ; N
ZAD01:    ldi   R17,90      ; . 0,1cek
          clr   R16         ; . 1ms
ZAD001:   dec   R16
          rjmp  PC+1
          rjmp  PC+1
          brne  ZAD001      ; ~1ms
          wdr               ;  WDT
          dec   R17
          brne  ZAD001      ; ~100ms
          dec   R18
          brne  ZAD01       ; ~N*0,1s
          ret

; /    . 
; :  R2...R5 - , R16 - 
; : R2...R5   T=1,   (-)
; . R17

MINUS:    clr   R17
          sub   R5,R16
          sbc   R4,R17
          sbc   R3,R17
          sbc   R2,R17
          brcc  MNS1         ; C=0, 
          neg   R5           ; C=1, 
          com   R4
          com   R3
          com   R2
          set                ; T=1,  (-)
MNS1:     ret

; /  4-    10
; :  R2 - R5 -    :  R2 - R5 - 
;                                   
;                                    R1 - 
; . R16 - . , R17 -  (10)

DL10:     ldi   R17,10      ; 
          ldi   R16,$020    ; - 
          clr   R1          ;  .  
DEL3:     rol   R5          ;    
          rol   R4
          rol   R3
          rol   R2
          rol   R1
          cp    R1,R17      ; R1-R17
          brcs  DEL1        ; R17>R1, C=1
          sub   R1,R17      ; R1-R17-->R1
          sec               ; 1-->C
          rjmp  DEL2
DEL1:     clc               ; 0-->C
DEL2:     dec   R16
          brne  DEL3        ;  32 
          rol   R5
          rol   R4
          rol   R3
          rol   R2
          ret

; /   
; :  R6 - R15
;           
; . R16, R17, R18, Z

INDIC:    ldi   R16,10        ; 10 
          ldi   ZL,6          ;  .  (R6)
INDIC2:   ld    R17,Z
          swap  R17           ; . .   .
          ldi   R18,4         ;  
INDIC6:   rol   R17           ; .  -->C
          brcc  INDIC3        ; C=0
          sbi   PORTB,DI      ; DI=1
INDIC3:   brcs  INDIC4        ; C=1
          cbi   PORTB,DI      ; DI=0
INDIC4:   sbi   PORTB,SK      ; SK=1
          rjmp  PC+1          ; 
          rjmp  PC+1          ; /
          cbi   PORTB,SK      ; SK=0
          dec   R18
          brne  INDIC6        ; . 
          inc   ZL            ;  . 
          dec   R16
          brne  INDIC2        ;  . 
          cbi   PORTB,DI
          ret

; /    
; : R29 - N  (0...Nmax), 0=Fmax, 1=Fmax/4...
; ZH=0
; : R4-R5 -  , R3=R2=0
;        c 
; . R0, R16, R17, R18, Z

RCHF:     ldi   R18,ConstF  ; .  800-12
          cpi   R29,Nmax+1  ;  ,  0...Nmax
          brcs  RCH1        ; =<Nmax
          ldi   R29,Nmax    ; >Nmax,  Nmax
RCH1:     mov   R16,R29     ; R29  
RCH4:     tst   R16
          breq  RCH2        ; R16=0
          dec   R16         ; 
          clc               ; C=0
          rol   R18         ; R18*2
          brcc  RCH3        ; C=0,  
RCH5:     ror   R18         ; , . R18
          inc   R16         ; . R16
          rjmp  RCH2
RCH3:     rol   R18         ; R18*2 ( R18*4)
          brcc  RCH4        ; C=0,  
          breq  RCH2        ; R18=0
          ror   R18         ; , . R18
          rjmp  RCH5
RCH2:     dec   R18         ; -1
          ldi   R17,$01     ;  CS13-CS10
          tst   R16
RCH7:     breq  RCH6        ; R16=0,  
          subi  R17,$FE     ; R17+2
          cpi   R17,$10
          brcc  RCH8        ; C=0, R17>0F,  0F
          dec   R16
          rjmp  RCH7
RCH8:     ldi   R17,$0F
RCH6:     andi  R17,$0F     ;  . .
          ori   R17,$90     ;  TMR1
          out   OCR1A,R18   ; TMR1    
          out   TCCR1,R17
          rcall ZADN        ;    0,5
          cpi   R29,Nmax-2
          brcs  DACON       ; C=1, <Nmax-2
          sbis  PINB,PINB1  ; PB1=1
          rjmp  PC-1        ;  PB1=1
          wdr               ;  WDT
          sbic  PINB,PINB1  ; PB1=0
          rjmp  PC-1        ;  PB1=0
          wdr               ;  WDT
          ldi   R17,05      ;  2ms
          clr   R16
RCH9:     dec   R16
          brne  RCH9
          dec   R17
          brne  RCH9
DACON:    sleep             ;  
          in    R5,ADCL     ; . 
          in    R4,ADCH     ; . 
          clr   R3
          clr   R2
          ret

;  WRITE EEPROM.
; : R16 -   R18 - 

WRITEE:   cli               ;  .
          out   EEAR,R16    ;   EEPROM
          out   EEDR,R18    ;  
          sbi   EECR,EEMWE  ;   EEMWE  
          sbi   EECR,EEWE   ;   EEWE -> 
WRITE1:   sbic  EECR,EEWE   ;    EEWE (2,5-4 mc)
          rjmp  WRITE1      ; 
          sei               ; . .
          ret

;  READ EEPROM
; :  R16 - 
; : R17 - 

READEE:   out   EEAR,R16    ;  EEPROM
          sbi   EECR,EERE   ;   EERE -> 
          in    R17,EEDR    ;    EEPROM -> R17
          ret

; , 
BEGIN:    cli               ; .  .
          in    R17,MCUSR   ; . MCUSR   RESET
          ldi   R16,$0D
          out   WDTCR,R16   ; . WDT  0,5
          wdr               ;  WDT
          clr   R16
          out   MCUSR,R16   ;   RESET
          out   GIMSK,R16   ;   .
          out   TIMSK,R16   ;  . 
          out   TCCR0,R16   ;  TMR0
          out   TCCR1,R16   ;  TMR1
          out   SFIOR,R16
          out   EECR,R16    ;  EEPROM
          ldi   R16,$60     ; SLEEP -  IDL, . .
          out   MCUCR,R16
          clr   ZH          ; ZH=0
          ldi   ZL,low(CALIBR*2) ;  . 
          lpm
          out   OSCCAL,R0   ; . 
          ldi   R16,$80
          out   ACSR,R16    ; . 
          ldi   R16,$02
          out   PORTB,R16   ; PB1=1
          ldi   R16,$1A     ; 0001.1010
          out   DDRB,R16    ; PB1,3,4-OUT, PB0,2,5-IN
          ldi   R16,$C1     ; 1100.0001
          out   ADMUX,R16   ; PB2-., PB0-.
          ldi   R16,$8C     ; 1000.1100
          out   ADCSR,R16   ; -., ., CK/16=100
          sei               ; . . .
          tst   R17
          breq  BG01        ; R17=0,  
          andi  R17,$0D     ; 0000.1101  . RESET
          brne  BG01        ; POWER, WDT  BROWN, 
; 
          ldi   R16,10      ; - 
          ldi   ZL,6        ;  . 
          ldi   R17,$0D     ;  L
NST4:     st    Z,R17
          inc   ZL
          dec   R16
          brne  NST4
          rcall INDIC       ;  LLLLLLLLLL
          clr   R29         ;  0
          rcall RCHF        ; . Fmax =800
          ldi   R18,05
          rcall ZAD01       ;  0,5
          rcall RCHF        ;   R2-R5
          tst   R4
          brne  NST1        ; .    0
          mov   R28,R5      ; .  
          cpi   R28,Cmax+1
          brcs  NST2        ; R28=<Cmax
NST1:     clr   R28         ;  >Cmax,  =0
NST2:     mov   R18,R28     ;   C
          com   R18         ; 
          ldi   R16,$01     ;   EEPROM  C .
          rcall READEE      ;   R17
          cpse  R17,R18     ; =, ,   
          rcall WRITEE      ;  , 
          rjmp  CIKL        ;   
BG01:     ldi   R16,$01     ;   C.
          rcall READEE      ; 
          mov   R28,R17     ; .  C.
          com   R28         ; 
          ldi   R29,Nmax    ;   max 
          rcall RCHF        ; . 12
          ldi   ZL,low(CONIND*2) ;  const .  .
          lpm
          mov   R18,R0
          rcall ZAD01       ; .  . 2
; 
CIKL:     rcall RCHF        ;   R2-R5
          mov   R17,R5      ; .  
          mov   R16,R4      ; .  
          cpi   R16,$03
          brcc  COMPUP      ; R16>=3
          tst   R16
          breq  COMPDWN     ; R16=0
          rjmp  DELTA       ;   
COMPUP:   cpi   R17,Umax+1
          brcs  DELTA       ; R17=<Umax
          cpi   R29,Nmax
          brcc  CMUP1       ;  >= Nmax
          inc   R29         ; R17>Umax, . 
CMUP1:    ldi   R16,$0E     ;  P  .
          mov   R6,R16
          mov   R7,R29      ; 
          inc   R7          ;    1...9
          ldi   R16,$0F     ;  (-)  .
          mov   R8,R16      ; (-)  . 
          mov   R9,R16
          mov   R10,R16
          mov   R11,R16
          mov   R12,R16
          mov   R13,R16
          mov   R14,R16
          mov   R15,R16
          rcall INDIC       ;   .
          rjmp  CIKL        ;  
COMPDWN:  cpi   R17,Umin
          brcc  DELTA       ; R17>=Umin
          tst   R29
          breq  DELTA       ;  =0
          dec   R29
          rjmp  CMUP1       ;      
;      
DELTA:    mov   R16,R29     ; 
DLT3:     tst   R16
          breq  DLT1        ;  0
          ldi   R17,$02     ; 
DLT2:     clc               ; C=0
          rol   R5          ; *2
          rol   R4          ; /
          rol   R3          ; /
          rol   r2          ; /
          dec   R17
          brne  DLT2        ; *4
          dec   R16
          rjmp  DLT3        ;    *4
DLT1:     cpi   R28,Cmax+1
          brcs  DLT5        ; R28=<Cmax
          clr   R28         ; R28>Cmax,  =0
DLT5:     mov   R16,R28
          clt               ; T=0
          rcall MINUS       ;   

;  4-    2  2-10 
; :  R2 - R5   :  R6 - R15
;                         
; . R1, R16, R17, R18, Z

          clc                ; C=0
          ldi   R18,10       ;  
          ldi   ZL,15        ;  R15
TRN2:     rcall DL10
          wdr                ;  WDT
          st    Z,R1
          dec   ZL
          dec   R18
          brne  TRN2
;   3-  
; , :  R6 - R15
;                  
; . R16, R17, R18, R19, Z

          ldi   R18,3         ; - . 
          ldi   R16,10        ;  
          ldi   ZL,5          ;  R6-1
OKR1:     inc   ZL            ; 
          ld    R17,Z         ; 
          tst   R17
          brne  OKR2          ;  1- . 
          dec   R16           ;  
          brne  OKR1          ;  
          rjmp  ZMN           ;  
OKR2:     sub   R16,R18       ; R16-3 -  
          brcs  ZMN           ; C=1,  3- . 
          breq  ZMN           ; Z=1, 3 . 
          add   ZL,R18        ;  1-  
          mov   R19,ZL        ;  Z
          ld    R17,Z         ; 1- . 
          cpi   R17,5
          brcs  OKR3          ; C=1, R17<5
          inc   R18
OKR4:     dec   ZL            ; R17>=5,  1  .
          ld    R17,Z
          inc   R17
          st    Z,R17
          cpi   R17,10
          brne  OKR3          ; R17  10
          dec   R18           ;  . 
          brne  OKR4
OKR3:     mov   ZL,R19        ; .  1- . 
          clr   R17
OKR5:     st    Z,R17         ;  
          inc   ZL
          dec   R16           ; 
          brne  OKR5
;  00  0A  
; , :  R6 - R15
;                  
; . R16, R17, Z

ZMN:      ldi   R16,10        ; 10 
          ldi   ZL,5          ;  R6-1
ZMN2:     inc   ZL            ;  R6
          ld    R17,Z         ; 
          tst   R17
          brne  ZMN3          ;  1- . 
          dec   R16           ;  
          brne  ZMN2          ;  
          ldi   R17,$0A       ;  ,  . 
          st    Z,R17
          rjmp  ZNAK          ;  
ZMN1:     ld    R17,Z
          tst   R17
          brne  ZMN3          ;  0
          ldi   R17,$0A       ;  00  0A
          st    Z,R17
ZMN3:     inc   ZL            ;   
          dec   R16           ;  
          brne  ZMN1
ZNAK:     brtc  OUTIN         ; T=0,  
          ldi   R16,$0F       ;  (-)
          mov   R6,R16        ; (-)  . 
;    (R6=R7=0)
; |---<---||-<-||-<-||-<-||-<-||-<-||-<-|
; R6  R7  R8   R9   R10  R11  R12  R13  R14  R15
;                                       |-<-00

OUTIN:    tst   R6
          breq  OUTIN1        ; R6=0
          mov   R7,R8         ; R6  0,  
          rjmp  OUTIN2
OUTIN1:   tst   R7
          breq  OUTIN3        ; R7=0
          mov   R6,R7         ; R7 <>0,   
          mov   R7,R8
          rjmp  OUTIN2
          mov   R7,R6
OUTIN3:   mov   R6,R8
OUTIN2:   mov   R8,R9
          mov   R9,R10
          mov   R10,R11
          mov   R11,R12
          mov   R12,R13
          mov   R13,R14
          clr   R14
          rcall INDIC         ;   .
          rjmp  CIKL          ;  
